# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render,redirect
from . import models

from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.views.decorators.cache import cache_control


def login(request):
    print(request.session.get('session',None))
        
    if(request.session.get('session',None)==True):
        print(request.session['session'])
        return redirect('arfa/profile')
    return render(request,'ARFA_app/login.html')   


def profile(request):
    if request.method=='POST' or request.session.get('session',None)==True:
        if(request.session.get('session',None)==True):
            if(request.session.get('type',None)=="student"):
                return render(request,'ARFA_app/home.html',request.session.get('args',None))
            else:
                return render(request,'ARFA_app/faculty_home.html',request.session.get('args',None))
        else:
            args={'user':request.POST['username'],'password':request.POST['password']}
            print(args['user'])
            authenticated=check_auth(args)
            if(not(authenticated["status"])):
                return redirect('/arfa/',authenticated)
            else:
                # return redirect(request,'ARFA_app/home.html',args)   
                request.session['username'] = args['user']
                request.session['session'] = True
                args={
                    'name':authenticated["object"].name,
                    'phone_number':authenticated["object"].phone_number,
                    'username':authenticated["object"].username,
                    'email_ID':authenticated["object"].email_ID,
                    'address':authenticated["object"].address,
                    'type':authenticated["type"]
                }
                request.session['args']=args
                if(authenticated['type']=="student"):
                    return render(request,'ARFA_app/home.html',args)
                else:
                    return render(request,'ARFA_app/faculty_home.html',args)
                
    else:
        return redirect('/arfa')   
    
def check_auth(args):
    tuple=models.Student.objects.filter(username=args["user"],password=args["password"])
        
    if len(tuple)==1 :
        return {'status':True,'object':tuple[0],'type':"student"}
    else :
        tuple=models.Faculty.objects.filter(username=args["user"],password=args["password"])
        if len(tuple)==1 :
            return {'status':True,'object':tuple[0],'type':"faculty"}
        else :
            return {'status':False}

def logout(request):
    request.session['session']=False
    print(request.session['username'])
    request.session.flush()
    return render(request,'ARFA_app/logout.html')   


def create_question(request):
    args={'username':request.session['username']}
    return render(request,'ARFA_app/create_question.html',args)

def view_personal_question(request):
    questions=[
        {
            'id':"q1",
            'id_drop':"dropdown"+"q1",
            'text':"I am the first question",
            'option':[
                {
                    'tag':"a",
                    'text':"I am option a for id 1"}, 
                {
                    'tag':"b",
                    'text':"I am option b for id 1"}
            ]
        },
        {
            'id':"q2",
            'id_drop':"dropdown"+"q2",
            'text':"I am the second question",
            'option':[
                {
                    'tag':"a",
                    'text':"I am option a for id 2"}, 
                {
                    'tag':"b",
                    'text':"I am option b for id 2"},
                {
                    'tag':"c",
                    'text':"I am option c for id 2"}
            
            ]
        }
    ]
    args={'username':request.session['username'],'questions':questions}     
    return render(request,'ARFA_app/view_personal_question.html',args)

def view_all_question(request):
    args={'username':request.session['username']}
    return render(request,'ARFA_app/view_all_question.html',args)


def create_Test(request):
    args={'username':request.session['username']}
    return render(request,'ARFA_app/create_Test.html',args)

def view_personal_Test(request):
    args={'username':request.session['username']}
    return render(request,'ARFA_app/view_personal_Test.html',args)

def view_all_Test(request):
    args={'username':request.session['username']}
    return render(request,'ARFA_app/view_all_Test.html',args)